autostew/urls.py
from django.conf.urls import include, url
from django.contrib import admin

urlpatterns = [
    url(r'^accounts/', include('autostew_web_account.urls', namespace='account'), name='account'),
    url(r'^admin/', admin.site.urls, name='admin'),
    url(r'^api/', include('autostew_web_api.urls', namespace='api'), name='api'),
    url(r'^contact/', include('autostew_web_contact.urls', namespace='contact'), name='contact'),
    url(r'^session/', include('autostew_web_session.urls', namespace='session'), name='session'),
    url(r'^user/', include('autostew_web_users.urls', namespace='users'), name='user'),
    url(r'^', include('autostew_web_home.urls', namespace='home'), name='home'),
]

autostew_web_session/urls.py
from django.conf.urls import url
from django.contrib.auth.decorators import login_required
from django.views.generic.base import TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.list import ListView

from autostew_web_session.models.models import Track
from autostew_web_session.models.session import SessionSetup, Session
from autostew_web_session.models.server import Server
from autostew_web_session.views import ParticipantDetailView, SessionList, TrackDetailView, SessionView
from . import views

app_name = 'session'
urlpatterns = [
    url(r'^tracks/?$', ListView.as_view(model=Track), name='tracks'),
    url(r'^tracks/(?P<pk>[0-9]+)/?$', TrackDetailView.as_view(), name='track'),
    url(r'^list/?$', SessionList.as_view(), name='sessions'),
    url(r'^servers/?$', ListView.as_view(model=Server), name='servers'),
    url(r'^servers/(?P<slug>.+)/?$', DetailView.as_view(model=Server, slug_field='name'), name='server'),
    url(r'^(?P<pk>[0-9]+)/?$', SessionView.as_view(), name='session'),
    url(r'^(?P<pk>[0-9]+)/events/?$', views.SessionEvents.as_view(), name='events'),
    url(r'^(?P<session_id>[0-9]+)/participant/(?P<participant_id>[0-9]+)/?$', ParticipantDetailView.as_view(), name='participant'),
    url(r'^snapshot/(?P<pk>[0-9]+)/?$', SessionView.as_view(), name='snapshot'),
    url(r'^setup/create/?$', login_required(views.CreateSessionView.as_view()), name='create_setup'),
    url(r'^setup/list/?$', ListView.as_view(model=SessionSetup, queryset=SessionSetup.objects.filter(is_template=True)), name='setups'),
    url(r'^setup/(?P<pk>[0-9]+)/?$', DetailView.as_view(model=SessionSetup), name='setup'),
]

autostew_web_session/models/member.py
from django.db import models

from autostew_web_enums.models import LeavingReason


class Member(models.Model):
    class Meta:
        ordering = ['name']

    parent = models.ForeignKey('self', null=True, blank=True)
    steam_user = models.ForeignKey('autostew_web_users.SteamUser')
    session = models.ForeignKey('Session')
    still_connected = models.BooleanField()

    ingame_load_state = models.ForeignKey('autostew_web_enums.MemberLoadState')
    ping = models.IntegerField()
    ingame_index = models.IntegerField()
    ingame_state = models.ForeignKey('autostew_web_enums.MemberState')
    join_time = models.IntegerField()
    is_host = models.BooleanField()
    leaving_reason = models.ForeignKey(LeavingReason, null=True, blank=True)

    vehicle = models.ForeignKey('Vehicle')
    livery = models.ForeignKey('Livery')
    refid = models.IntegerField()
    steam_id = models.CharField(max_length=200)
    name = models.CharField(max_length=200)

    setup_used = models.BooleanField()
    controller_gamepad = models.BooleanField()
    controller_wheel = models.BooleanField()
    aid_steering = models.BooleanField()
    aid_braking = models.BooleanField()
    aid_abs = models.BooleanField()
    aid_traction = models.BooleanField()
    aid_stability = models.BooleanField()
    aid_no_damage = models.BooleanField()
    aid_auto_gears = models.BooleanField()
    aid_auto_clutch = models.BooleanField()
    model_normal = models.BooleanField()
    model_experienced = models.BooleanField()
    model_pro = models.BooleanField()
    model_elite = models.BooleanField()
    aid_driving_line = models.BooleanField()
    valid = models.BooleanField()

    def create_snapshot(self, session_snapshot):
        snapshot = Member.objects.get(pk=self.pk)
        snapshot.pk = None
        snapshot.parent = self
        snapshot.session = session_snapshot
        snapshot.save()
        return snapshot

    def get_participant(self, session):
        return session.participant_set.filter(is_player=True, refid=self.refid)[0]

    def send_chat(self, message, server):
        return server.send_chat(message, self.refid)

    def kick(self, server, ban_seconds):
        return server.kick(self.refid, ban_seconds)

autostew_web_session/models/models.py
from django.core.urlresolvers import reverse
from django.db import models
from django.db.models.aggregates import Min

from autostew_web_enums import models as enum_models


class Track(models.Model):
    class Meta:
        ordering = ['name']

    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)
    name = models.CharField(max_length=100)
    grid_size = models.SmallIntegerField()
    track_latitude = models.IntegerField(default=0)
    track_longitude = models.IntegerField(default=0)
    track_altitude = models.IntegerField(default=0)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown', 'grid_size': 0})[0]

    def get_absolute_url(self):
        return reverse('session:track', args=[str(self.id)])

    def get_fastest_laps_by_vehicle(self, vehicle):
        return Lap.objects.filter(
            session__setup_actual__track=self,
            participant__vehicle=vehicle,
            count_this_lap=True,
            participant__is_player=True,
        ).values(
            'participant',
            'participant__member__steam_user__display_name',
            'participant__vehicle__name'
        ).annotate(fastest_lap_time=Min('lap_time')).order_by('fastest_lap_time')

    def get_fastest_laps_by_vehicle_class(self, vehicle_class):
        return Lap.objects.filter(
            session__setup_actual__track=self,
            participant__vehicle__vehicle_class=vehicle_class,
            count_this_lap=True,
            participant__is_player=True,
        ).values(
            'participant__name',
            'participant__vehicle__name'
        ).annotate(fastest_lap_time=Min('lap_time')).order_by('fastest_lap_time')


class VehicleClass(models.Model):
    class Meta:
        ordering = ['name']

    name = models.CharField(max_length=50)
    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown'})[0]


class Vehicle(models.Model):
    class Meta:
        ordering = ['name']

    name = models.CharField(max_length=50)
    ingame_id = models.IntegerField(help_text='pCars internal ID', db_index=True)
    vehicle_class = models.ForeignKey(VehicleClass, null=True)

    def __str__(self):
        return self.name

    @classmethod
    def get_or_create_default(cls, ingame_id):
        return cls.objects.get_or_create(ingame_id=ingame_id, defaults={'name': 'Unknown'})[0]


class Livery(models.Model):
    class Meta:
        ordering = ['vehicle__name', 'name']
        verbose_name_plural = "Liveries"

    name = models.CharField(max_length=50)
    id_for_vehicle = models.IntegerField(help_text='pCars internal ID', db_index=True)
    vehicle = models.ForeignKey(Vehicle, null=True)

    @classmethod
    def get_or_create_default(cls, id_for_vehicle, vehicle):
        return cls.objects.get_or_create(
            id_for_vehicle=id_for_vehicle,
            vehicle=vehicle,
            defaults={'name': 'Unknown'}
        )[0]

    def __str__(self):
        return "{} for {}".format(self.name, self.vehicle.name)


class SetupRotationEntry(models.Model):
    class Meta:
        ordering = ('server', 'order', )
        verbose_name_plural = "Rotated setups"
    order = models.IntegerField(help_text='Index of setup in order')
    setup = models.ForeignKey('SessionSetup', on_delete=models.CASCADE, limit_choices_to={'is_template': True})
    server = models.ForeignKey('Server', on_delete=models.CASCADE)


class SetupQueueEntry(models.Model):
    class Meta:
        ordering = ('server', 'order', )
        verbose_name_plural = "Queued setups"
    order = models.IntegerField(help_text='Index of setup in order')
    setup = models.ForeignKey('SessionSetup', on_delete=models.CASCADE, limit_choices_to={'is_template': True})
    server = models.ForeignKey('Server', on_delete=models.CASCADE)


class RaceLapSnapshot(models.Model):
    class Meta:
        ordering = ['session_id', 'lap']

    session = models.ForeignKey('Session')
    snapshot = models.OneToOneField('Session', related_name='+')
    lap = models.IntegerField()

    def get_absolute_url(self):
        return self.snapshot.get_absolute_url()


class Lap(models.Model):
    class Meta:
        ordering = ['session_id', 'lap']

    session = models.ForeignKey('Session', related_name='lap_set')
    session_stage = models.ForeignKey(enum_models.SessionStage)
    participant = models.ForeignKey('Participant')
    lap = models.IntegerField()
    count_this_lap = models.BooleanField()
    lap_time = models.IntegerField()
    position = models.IntegerField()
    sector1_time = models.IntegerField()
    sector2_time = models.IntegerField()
    sector3_time = models.IntegerField()
    distance_travelled = models.IntegerField()

    def is_personal_sector1_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector1_time')

    def is_personal_sector2_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector2_time')

    def is_personal_sector3_race_best_in_stage(self):
        return self._best_in_stage_evaluation('sector3_time')

    def is_personal_race_best_in_stage(self):
        return self._best_in_stage_evaluation('lap_time')

    def _best_in_stage_evaluation(self, field_name):
        return getattr(self, field_name) <= self.participant.lap_set.filter(
            **{
                '{}__gt'.format(field_name): 0,
                'session_stage': self.session_stage
            }
        ).aggregate(Min(field_name))['{}__min'.format(field_name)]


class Sector(models.Model):
    class Meta:
        ordering = ['session_id', 'lap', 'sector']

    session = models.ForeignKey('Session')
    session_stage = models.ForeignKey(enum_models.SessionStage)
    participant = models.ForeignKey('Participant')
    lap = models.IntegerField()
    count_this_lap = models.BooleanField()
    sector = models.SmallIntegerField()
    sector_time = models.IntegerField()

autostew_web_session/forms.py
import logging

from django.forms import ModelForm

from autostew_web_session.models.session import SessionSetup


class SessionSetupForm(ModelForm):
    def save(self, commit=True):
        session_setup = super(SessionSetupForm, self).save(commit=False)
        session_setup.is_template = True
        session_setup.server_controls_setup = True
        session_setup.server_controls_track = True
        session_setup.server_controls_vehicle_class = True
        session_setup.server_controls_vehicle = True
        if commit:
            session_setup.save()

        return session_setup

    class Meta:
        exclude = ['is_template', 'server_controls_setup', 'server_controls_track', 'server_controls_vehicle', 'server_controls_vehicle_class']
        model = SessionSetup

autostew_web_session/views.py
import logging

from django.core.urlresolvers import reverse_lazy
from django.shortcuts import get_object_or_404
from django.views import generic
from django.views.generic import FormView

from autostew_web_session import models
from autostew_web_session.models.models import Track, Vehicle, VehicleClass
from autostew_web_session.models.event import Event
from autostew_web_session.models.participant import Participant
from autostew_web_session.models.session import SessionSetup, Session
from autostew_web_session.models.server import Server
from .forms import SessionSetupForm


class CreateSessionView(FormView):
    template_name = 'autostew_web_session/create_form.html'
    form_class = SessionSetupForm
    success_url = reverse_lazy('session:setups')

    def form_valid(self, form):
        form.save()
        return super(CreateSessionView, self).form_valid(form)


class SessionEvents(generic.ListView):
    model = Event

    def get_queryset(self):
        self.session = get_object_or_404(Session, id=self.kwargs['pk'])
        return self.session.event_set.all()

    def get_context_data(self, **kwargs):
        context = super(SessionEvents, self).get_context_data(**kwargs)
        context['session'] = self.session
        return context


class SessionView(generic.DetailView):
    model = Session

    def get_context_data(self, **kwargs):
        context = super(SessionView, self).get_context_data(**kwargs)
        context['parent'] = context['object'] if context['object'].parent is None else context['object'].parent
        return context


class SessionList(generic.ListView):
    model = Session

    def get_context_data(self, **kwargs):
        context = super(SessionList, self).get_context_data(**kwargs)
        context['sessions_in_progress'] = (server.current_session for server in Server.objects.all() if server.current_session)
        context['sessions_history'] = Session.objects.filter(finished=True, parent=None, is_final_result=True).order_by('-id')[:30]
        context['setups_in_rotation'] = SessionSetup.objects.filter(rotated_in_server__in=Server.objects.all())
        return context


class ParticipantDetailView(generic.DetailView):
    model = Participant

    def get_object(self, queryset=None):
        return get_object_or_404(
            Participant,
            session__id=self.kwargs['session_id'],
            ingame_id=self.kwargs['participant_id']
        )


class TrackDetailView(generic.DetailView):
    model = Track

    def get_context_data(self, **kwargs):
        context = super(TrackDetailView, self).get_context_data(**kwargs)
        context['vehicle_classes'] = VehicleClass.objects.all()
        context['vehicles'] = Vehicle.objects.all()
        if self.request.GET.get('vehicle'):
            context['vehicle'] = get_object_or_404(Vehicle, ingame_id=self.request.GET.get('vehicle'))
            context['laps'] = context['object'].get_fastest_laps_by_vehicle(context['vehicle'])
        elif self.request.GET.get('vehicle_class'):
            context['vehicle_class'] = get_object_or_404(VehicleClass, ingame_id=self.request.GET.get('vehicle_class'))
            context['laps'] = context['object'].get_fastest_laps_by_vehicle_class(context['vehicle_class'])
        else:
            context['laps'] = []
        return context

autostew_web_session/templates/autostew_web_session/create_form.html
{% extends "autostew_web_home/base.html" %}

{% block content %}
    <h1>New setup</h1>
    <form class="form-group" action="{% url 'session:create_setup' %}" method="post">
        {% csrf_token %}
        <table class="table table-striped table-hover">
            {{ form.as_table }}
        </table>

        <input type="submit" name="submit" class="btn btn-primary form-control" value="Create session setup" >
    </form>
{% endblock %}

autostew_web_session/templates/autostew_web_session/ds_admin.html
{% extends "autostew_web_home/base.html" %}

{% block content %}

    <h1 class="page-header">Dedicated server admin zone</h1>
    <h3>Coming soon!</h3>
    <p>
        Here the managers of dedicated servers connected to Autostew will be able to control their DS.
    </p>
    <p>
        Some of the features we want to implement here:
    </p>
    <ul>
        <li>Start and stop the Autostew connection.</li>
        <li>Reconnect your DS after a restart.</li>
        <li>Enable/disable kicking.</li>
        <li>Enable/disable ratings.</li>
        <li>Manage your setup rotations.</li>
    </ul>
    <h3>I have a DS and want to connect it to Autostew!</h3>
    <p>
        We love to hear that, <a href="{% url 'contact:contact' %}">contact us here</a>!
    </p>
{% endblock %}

autostew_web_session/templates/autostew_web_session/server_detail.html
{% extends "autostew_web_home/base.html" %}

{% block content %}
    <h1 class="page-header">
        {{ server.name }}
        <small>
            {% if server.running %}
                <span class="label label-success">Running</span>
            {% else %}
                <span class="label label-danger">Not running</span>
            {% endif %}
        </small>
    </h1>
    {% include 'autostew_web_session/server_badge.html' with server=server %}

    {% if server.setupqueueentry_set.exists %}
        <h2>Setup queue</h2>
        <ul>
            {% for setup in server.setupqueueentry_set.all %}
                <li><a href="{{ setup.setup.get_absolute_url }}">{{ setup.setup.name }}</a></li>
            {% endfor %}
        </ul>
    {% endif %}

    {% if server.setuprotationentry_set.exists %}
        <h2>Rotation</h2>
        <ul>
            {% for setup in server.setuprotationentry_set.all %}
                <li><a href="{{ setup.setup.get_absolute_url }}">{{ setup.setup.name }}</a></li>
            {% endfor %}
        </ul>
    {% endif %}

    <h2>Last sessions</h2>
    <ul>
        {% for session in server.get_latest_sessions %}
            <li><a href="{{ session.get_absolute_url }}">{{ session }}</a></li>
        {% empty %}
            <li>No sessions yet.</li>
        {% endfor %}
    </ul>
{% endblock %}

autostew_web_session/templates/autostew_web_session/session_detail.html
{% extends "autostew_web_home/base.html" %}
{% load extra_filters %}

{% block content %}
    <div class="row">
        <div class="col-xs-12 col-md-4 placeholder">
            <h3>
                {% if parent.finished %}<span class="label label-success">finished</span>
                {% elif parent.running %}<span class="label label-danger">in progress</span>
                {% endif %}
            </h3>

            <h4>
                {{ parent.setup_actual.track.name }}
            </h4>

            <h4>
                {% if parent.setup_actual.get_vehicle_restriction %}
                    {{ parent.setup_actual.get_vehicle_restriction }}
                {% else %}
                    Any car
                {% endif %}
            </h4>

            <p>
                Real time: {{ session.timestamp|date }} {{ session.timestamp|time }}<br>
                In-game time (x{{ session.setup_actual.date_progression }}):
                {{ session.current_year }}-{{ session.current_month }}-{{ session.current_day }}
                {{ session.current_hour }}:{{ session.current_minute }}
            </p>

            <p>
                {% if parent.setup_actual.weather_slots == 0 %}Real weather{% endif %}
                <span style="font-size: xx-large">
                    {% if parent.setup_actual.weather_slots > 0 %}{{ parent.setup_actual.weather_1.get_icon_or_name|safe }}{% endif %}
                    {% if parent.setup_actual.weather_slots > 1 %}{{ parent.setup_actual.weather_2.get_icon_or_name|safe }}{% endif %}
                    {% if parent.setup_actual.weather_slots > 2 %}{{ parent.setup_actual.weather_3.get_icon_or_name|safe }}{% endif %}
                    {% if parent.setup_actual.weather_slots > 3 %}{{ parent.setup_actual.weather_4.get_icon_or_name|safe }}{% endif %}
                </span>
                (x{{ parent.setup_actual.weather_progression }})
            </p>
            <p>
                <i class="wi wi-thermometer" title="Ambient temperature"></i> {{ session.temperature_ambient|temp }} ºC |
                <span class="glyphicon glyphicon-road" title="Track temperature"></span> {{ session.temperature_track|temp }} ºC |
                <i class="wi wi-barometer" title="Air pressure"></i> {{ session.air_pressure|pressure }} hPa
                <br>
                Track wetness: {{ session.wetness_avg|percent }}%
            </p>
        </div>
        <div class="col-xs-12 col-md-4 placeholder" style="text-align: center">
            <h2>
                {{ session.get_nice_state|upper }}
            </h2>

            {% if session == parent and session.running %}
                <script>var autorefresh = setTimeout(function () { location.reload(1); }, 10000);</script>
                <p><button class="btn btn-default" onclick="clearTimeout(autorefresh)">
                    <span class="glyphicon glyphicon-pause"></span> refresh
                </button></p>
            {% endif %}
            {% include 'autostew_web_session/server_badge.html' with server=session.server %}

            <h3>
                {% if session.previous_in_session %}
                    <a class="btn btn-default" href="{% url 'session:snapshot' session.previous_in_session.id %}">
                        <span class="glyphicon glyphicon-triangle-left" aria-hidden="true"></span>
                    </a>
                {% else %}
                    <a class="btn btn-default disabled" href="#">
                        <span class="glyphicon glyphicon-triangle-left" aria-hidden="true"></span>
                    </a>
                {% endif %}
                Navigate
                {% if session.next_in_session %}
                    <a class="btn btn-default" href="{% url 'session:snapshot' session.next_in_session.id %}">
                        <span class="glyphicon glyphicon-triangle-right" aria-hidden="true"></span>
                    </a>
                {% else %}
                    <a class="btn btn-default disabled" href="#">
                        <span class="glyphicon glyphicon-triangle-right" aria-hidden="true"></span>
                    </a>
                {% endif %}
            </h3>

            {% if parent.setup_actual.practice1_length %}{{ parent.setup_actual.practice1_length }} minutes practice<br>{% endif %}
            {% if parent.setup_actual.practice2_length %}{{ parent.setup_actual.practice2_length }} minutes practice<br>{% endif %}
            {% if parent.setup_actual.qualify_length %}{{ parent.setup_actual.qualify_length }} minutes qualifying<br>{% endif %}
            {% if parent.setup_actual.warmup_length %}{{ parent.setup_actual.warmup_length }} minutes warmup<br>{% endif %}
            <b>{{ parent.setup_actual.race1_length }} {{ parent.setup_actual.get_race_length_unit }} race</b><br>
            {% if parent.setup_actual.enforced_pitstop %}Mandatory pitstop{% endif %}

            <p>
                {% include 'autostew_web_session/session_detail_lap_selector.html' with session=parent %}

                <a class="btn btn-{% if session.parent %}default{% else %}primary{% endif %}"
                   href="{% if session.parent %}{% url 'session:session' session.parent_id %}{% else %}#{% endif %}">
                    Latest
                </a>
            </p>
        </div>
        <div class="col-xs-12 col-md-4 placeholder" style="text-align: center">

            <h3>Settings</h3>
            <p>
                {% if parent.setup_actual.rolling_starts %}Rolling start<br>{% endif %}
                {{ parent.setup_actual.damage.name|title }} damage<br>
                {{ parent.setup_actual.tire_wear.name|title }} tire wear<br>
                {{ parent.setup_actual.fuel_usage.name|title }} fuel usage<br>
                {{ parent.setup_actual.penalties.name|title }} penalties<br>
                {{ parent.setup_actual.allowed_views.name|title }} view
            </p>

            <p>
                <span class="label label-{% if parent.setup_actual.allow_custom_vehicle_setup %}success{% else %}danger{% endif %}">Custom car setups</span>
                {% if parent.setup_actual.force_realistic_driving_aids %}
                    <span class="label label-warning">ABS</span>
                    <span class="label label-warning">SC</span>
                    <span class="label label-warning">TCS</span>
                {% else %}
                    <span class="label label-{% if parent.setup_actual.abs_allowed %}success{% else %}danger{% endif %}">ABS</span>
                    <span class="label label-{% if parent.setup_actual.sc_allowed %}success{% else %}danger{% endif %}">SC</span>
                    <span class="label label-{% if parent.setup_actual.tcs_allowed %}success{% else %}danger{% endif %}">TCS</span>
                {% endif %}

                <span class="label label-{% if parent.setup_actual.force_manual %}danger{% else %}success{% endif %}">Automatic transm.</span>
                <span class="label label-{% if parent.setup_actual.mechanical_failures %}success{% else %}danger{% endif %}">Mechanical failures</span>
                <span class="label label-{% if parent.setup_actual.auto_start_engine %}success{% else %}danger{% endif %}">Auto engine start</span>
                <span class="label label-{% if parent.setup_actual.ghost_griefers %}success{% else %}danger{% endif %}">Ghost griefers</span>
            </p>

            <p>
                <a href="{{ parent.setup_actual.get_absolute_url }}" class="btn btn-default">
                    Setup: {{ parent.setup_actual.name }}
                </a>
                <a href="{{ parent.setup_actual.get_track_url }}" class="btn btn-default">
                    Leaderboard
                </a>
            </p>
        </div>
    </div>

    <div class="table-responsive">
        <table class="table table-striped table-hover table-condensed">
            <thead>
                <tr>
                    <th></th>
                    <th>Name</th>
                    <th>Lap</th>
                    <th>Last lap</th>
                    <th>Best lap</th>
                    <th>Gap</th>
                    <th>Status</th>
                </tr>
            </thead>
            {% for participant in session.get_connected_participants %}
                <tr>
                    <td style="white-space: nowrap; width: 1%;">
                        <div style="font-size: 220%; float: left; clear: left; padding-right: 15px">
                            P{{ participant.race_position }}
                            <a href="{{ participant.get_absolute_url }}">
                                <span class="glyphicon glyphicon-list-alt" aria-hidden="true" title="To race results"></span>
                            </a>
                            {% if participant.is_player %}
                                <a href="{{ participant.member.steam_user.get_absolute_url }}">
                                    <span class="glyphicon glyphicon-user" aria-hidden="true" title="To profile"></span>
                                </a>
                            {% endif %}
                        </div>
                    </td>
                    <td>
                        <b>{{ participant.name }}</b>
                        {% if participant.is_player %}
                            {% include 'autostew_web_users/safetyclass_label.html' with safetyclass=participant.member.steam_user.safety_class %}
                        {% endif %}
                        <br>
                        {% if not participant.is_player %}
                            <span class="label label-default">
                                <span class="glyphicon glyphicon-cog" aria-hidden="true"></span>
                                {{ parent.setup_actual.opponent_difficulty }}
                            </span>
                        {% else %}
                            {% if participant.member.steam_user.elo_rating %}
                                <span class="label label-default">{{ participant.member.steam_user.elo_rating }}</span>
                            {% endif %}
                        {% endif %}
                        &nbsp;
                        {{ participant.vehicle.name }}
                    </td>
                    <td>
                        {{ participant.current_lap }}
                    </td>
                    <td>
                        {% if participant.last_lap_time %}

                            <span class="
                                {% if participant.last_lap_is_fastest_in_race %}
                                    label label-success
                                {% elif participant.last_lap_is_fastest_in_shapshot %}
                                    label label-default
                                {% endif %}
                            ">{{ participant.last_lap_time|milli_to_nicetime }}</span>
                        {% else %}
                            ---
                        {% endif %}
                    </td>
                    <td>
                        {% if participant.fastest_lap_time %}
                            <span class="
                                {% if participant.fastest_lap_is_fastest_in_race %}
                                    label label-primary
                                {% endif %}
                            ">{{ participant.fastest_lap_time|milli_to_nicetime }}</span>
                        {% else %}
                            ---
                        {% endif %}
                    </td>
                    <td>
                        {{ participant.gap|milli_to_nicetime }}
                    </td>
                    <td>
                        {% if participant.still_connected %}
                            <span class="
                                {% if participant.state.in_race %}
                                    label label-primary
                                {% else %}
                                    label label-danger
                                {% endif %}
                            ">{{ participant.state.name }}</span>
                        {% else %}
                            <span class="label label-danger">{{ participant.member.leaving_reason.name }}</span>
                        {% endif %}
                    </td>
                </tr>
            {% endfor %}
            <tfoot>
                <tr>
                    <th></th>
                    <th>Name</th>
                    <th>Lap</th>
                    <th>Last lap</th>
                    <th>Best lap</th>
                    <th>Gap</th>
                    <th>Status</th>
                </tr>
            </tfoot>
        </table>
    </div>

    <p>
        Disconnected participants:
        {% for participant in parent.get_disconnected_participants %}
            {{ participant.name }} ({{ participant.member.leaving_reason.name }})
        {% endfor %}
    </p>

    <p>
        <a href="{% url 'session:events' parent.id %}">Events</a>
    </p>
{% endblock %}

autostew_web_session/templates/autostew_web_session/session_detail_lap_selector.html
{% if session.racelapsnapshot_set.exists %}
    <div class="btn-group">
        <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            {% if session.racelapsnapshot_set.first.exists %}
                Lap {{ session.racelapsnapshot_set.first.lap }}
            {% else %}
                Go to lap
            {% endif %}
            <span class="caret"></span>
            <span class="sr-only">Toggle Dropdown</span>
        </button>
        <ul class="dropdown-menu">
            {% for lap in session.racelapsnapshot_set.all %}
                <li><a href="{{ lap.get_absolute_url }}">{{ lap.lap }}</a></li>
            {% endfor %}
        </ul>
    </div>
{% endif %}